#include "WProgram.h"
int getSensorValue(int sUltraSoundSignal);
/* Ultrasound Sensor
 *------------------
 *
 * Reads values (00014-01199) from an ultrasound sensor (3m sensor)
 * and writes the values to the serialport.
 *
 * http://www.xlab.se | http://www.0j0.org
 * copyleft 2005 Mackie for XLAB | DojoDave for DojoCorp
 *
 */
int ultraSoundSignal1 = 5;             // Ultrasound signal pin
int ultraSoundSignal2 = 7;             // Ultrasound signal pin
int val = 0;
int ultrasoundValue1 = 0; 
int ultrasoundValue2 = 0; 
int timecount = 0;  // Echo counter                   
//int ledPin = 13;                      // LED connected to digital pin 13

void setup() {
  beginSerial(9600);                  // Sets the baud rate to 9600
  //pinMode(ledPin, OUTPUT);            // Sets the digital pin as output
}

int getSensorValue(int sUltraSoundSignal) {
  timecount = 0;
  val = 0;
  pinMode(sUltraSoundSignal, OUTPUT);     // Switch signalpin to output

  /* Send low-high-low pulse to activate the trigger pulse of the sensor
   * -------------------------------------------------------------------
   */
  digitalWrite(sUltraSoundSignal, LOW);   // Send low pulse 
  delayMicroseconds(2);                            // Wait for 2 microseconds
  digitalWrite(sUltraSoundSignal, HIGH);  // Send high pulse 
  delayMicroseconds(5);                            // Wait for 5 microseconds
  digitalWrite(sUltraSoundSignal, LOW);   // Holdoff

  /* Listening for echo pulse
   * -------------------------------------------------------------------
   */
  pinMode(sUltraSoundSignal, INPUT);      // Switch signalpin to input
  val = digitalRead(sUltraSoundSignal);   // Append signal value to val

  while(val == LOW) {                    // Loop until pin reads a high value
    val = digitalRead(sUltraSoundSignal);
  }

  while(val == HIGH) {                   // Loop until pin reads a high value
    val = digitalRead(sUltraSoundSignal);
    timecount = timecount +1;            // Count echo pulse time
  }
  return timecount;
}

void loop() {
  /* Writing out values to the serial port
   * -------------------------------------------------------------------
   */
  ultrasoundValue1 = getSensorValue(ultraSoundSignal1);          // Append echo pulse time to ultrasoundValue
  ultrasoundValue2 = getSensorValue(ultraSoundSignal2);          // Append echo pulse time to ultrasoundValue
  //serialWrite('A');                  
  //printByte(ultrasoundValue1);    // Access treatSensorValue method
  
  printByte('A');
  printInteger(ultrasoundValue1);
  printByte(10);
  printByte(13);
  delay(50);
  printByte('B');
  printInteger(ultrasoundValue2);
  printByte(10);
  printByte(13);
  delay(50);
  
  /* Delay of program
   * -------------------------------------------------------------------
   */
  delay(100);
}

